/*	PLUGIN REDIRECT
	WRITTEN BY: [WING] Sir Drink a lot
	visit www.adminmod.de
	
	DESCRIPTION: 	
	- If you write "/server" in chat, a serverlist-menu will open, where you can select the server.
	- You must use a redirectserver.cfg for more redirect servers.(hostnameIP:Port)
	- All redirections are logged in 'redirectlog.cfg'			
			
	---Changelog---
	26.02.09:	+ changed chat command to "/server", before it was "redirect me"
			+ translated in english
			- removed consgreet message
			- removed repeat message
			- removed command admin_redirect 'player'
	19.01.03:	- first release
*/

#include <core>
#include <console>
#include <string>
#include <admin>
#include <adminlib>

new STRING_VERSION[MAX_DATA_LENGTH] = "26.02.09";

new RedirectServerCFG[MAX_TEXT_LENGTH]="addons/adminmod/config/redirectserver.cfg";
new RedirectLogCFG[MAX_TEXT_LENGTH]="addons/adminmod/config/redirectlog.cfg";

new MenuID[MAX_PLAYERS];
new SelectedServerLoop[MAX_PLAYERS]={1,1,...};
new SelectedServer[MAX_PLAYERS];

/*Loading server list*/
#define MAX_IPS	20
new servercount=0;
new ServerIP[MAX_IPS][MAX_TEXT_LENGTH];
new Servername[MAX_IPS][MAX_TEXT_LENGTH];


public plugin_init() {
	plugin_registerinfo("PLUGIN SDAL REDIRECT","Redirect to another server",STRING_VERSION);
	plugin_registercmd("radio1","SetMenuData",ACCESS_ALL);
	plugin_registercmd("radio2","SetMenuData",ACCESS_ALL);
	plugin_registercmd("radio3","SetMenuData",ACCESS_ALL);
	plugin_registercmd("buyequip","SetMenuData",ACCESS_ALL);
	plugin_registercmd("buy","SetMenuData",ACCESS_ALL);
	plugin_registercmd("chooseteam","SetMenuData",ACCESS_ALL);
	plugin_registercmd("menuselect","menuselect",ACCESS_ALL);
	plugin_registercmd("showbriefing","SetMenuData",ACCESS_ALL);
	plugin_registercmd("say","HSay",ACCESS_ALL);
	plugin_registercmd("say_team","HSay",ACCESS_ALL);
	plugin_registerhelp("say",ACCESS_ALL,"say '/server':opens menue with serverlist, where u can choose to connect to.");

	if(!getvar("file_access_read")){
		selfmessage("[SDAL-REDIRECT] file_access_read 0 -> plugin error!! Read manuell!");
	}
	if(!getvar("file_access_write")){
		selfmessage("[SDAL-REDIRECT] file_access_write 0 -> plugin error!! Read manuell!");
	}
	load_serverlist();
	
	return PLUGIN_CONTINUE;
}

/*Ldt die Serverliste*/
load_serverlist(){
	new Data[MAX_DATA_LENGTH];
	new Text[MAX_TEXT_LENGTH];
	new j;
	new iLineCount;
	
	iLineCount=filesize(RedirectServerCFG);
	if(iLineCount>=MAX_IPS){
		snprintf(Text,MAX_TEXT_LENGTH,"[SDAL-REDIRECT] Too many lines in redirectserver.cfg. Increase MAX_IPS in sma file and recompile!");
		selfmessage(Text);
		iLineCount=MAX_IPS;
	}
	for(j=1; j <= iLineCount; j++){
		readfile(RedirectServerCFG,Data,j,MAX_TEXT_LENGTH);
		if(strncmp(Data,"//",2)!=0 && strlen(Data)!=0 && strncmp(Data,";",1)!=0){
			servercount++;
			strsplit(Data,"",Servername[servercount],MAX_TEXT_LENGTH,ServerIP[servercount],MAX_TEXT_LENGTH);
			
		}
	}
	snprintf(Text,MAX_TEXT_LENGTH,"[SDAL-REDIRECT] %i servers loaded successfully",servercount);
	selfmessage(Text);
	return PLUGIN_CONTINUE;
}

public HSay(HLCommand,HLData,HLUserName,UserIndex) {
	new Data[MAX_DATA_LENGTH];
	new User[MAX_NAME_LENGTH];
	convert_string(HLData,Data,MAX_DATA_LENGTH);
	convert_string(HLUserName,User,MAX_DATA_LENGTH);
	strstripquotes(Data);
	
	if(strcmp(Data,"/server")==0){
		redirectmenu(User,UserIndex);
		return PLUGIN_HANDLED;
	}
	return PLUGIN_CONTINUE;
}

/*Menue*/
redirectmenu(User[],UserIndex){
	new Text[512];
	new Command[MAX_TEXT_LENGTH];
	new i;
	new l=0;
	new a=1;
	new keys=0;
	snprintf(Text,MAX_TEXT_LENGTH,"\yRedirect Server-List:^n");
	for(i=SelectedServerLoop[UserIndex];i<=servercount;i++){
		l++;
		snprintf(Command,MAX_TEXT_LENGTH,"\w^n%i. %s",l,Servername[i]);
		strcat(Text,Command,MAX_TEXT_LENGTH);
		a+=a;
		keys=a-1;
		if(l==5){
			if(servercount>=SelectedServerLoop[UserIndex]+5){
				strcat(Text,"\y^n^n8. Next",MAX_TEXT_LENGTH);
				keys+=128;
			}
			break;
		}
	}
	if(SelectedServerLoop[UserIndex]>=5){
		strcat(Text,"\y^n^n9. Back",MAX_TEXT_LENGTH);
		keys+=256;
	}
	strcat(Text,"\r^n^n0. Cancel",MAX_TEXT_LENGTH);
	keys+=512;
	menu(User,Text,keys);
	MenuID[UserIndex]=1;
	return 0;
}

/*Auswertung der Menauswahl*/
public menuselect(HLCommand,HLData,HLUserName,UserIndex){
	new Data[MAX_DATA_LENGTH];
	new User[MAX_NAME_LENGTH];
  	convert_string(HLData,Data,MAX_DATA_LENGTH);
	convert_string(HLUserName,User,MAX_NAME_LENGTH);
	
	if(MenuID[UserIndex]==1){
		SelectedServer[UserIndex]=strtonum(Data);
		if(SelectedServer[UserIndex]==8){
			SelectedServerLoop[UserIndex]=SelectedServerLoop[UserIndex]+5;
			redirectmenu(User,UserIndex);
			return PLUGIN_HANDLED;
		}else if(SelectedServer[UserIndex]==9){
			SelectedServerLoop[UserIndex]=SelectedServerLoop[UserIndex]-5;
			redirectmenu(User,UserIndex);
			return PLUGIN_HANDLED;
		}else if(SelectedServer[UserIndex]==10){
			reset_array(UserIndex);
			return PLUGIN_HANDLED;
		}else{
			if(SelectedServerLoop[UserIndex]>=5){
				SelectedServer[UserIndex]=SelectedServerLoop[UserIndex]+SelectedServer[UserIndex]-1;
			}else{
				SelectedServer[UserIndex]=SelectedServer[UserIndex];
			}
			redirect(User,SelectedServer[UserIndex]);
			return PLUGIN_HANDLED;
		}
	}
	return PLUGIN_CONTINUE;
}

public plugin_disconnect(HLUserName,UserIndex){
	if(MenuID[UserIndex]==1){
	     	reset_array(UserIndex);   	
	}
	return PLUGIN_CONTINUE;
}

public SetMenuData(HLCommand,HLData,HLUserName,UserIndex){
	if(MenuID[UserIndex]==1){
		reset_array(UserIndex);
	}
	return PLUGIN_CONTINUE;
}

reset_array(UserIndex){
	MenuID[UserIndex]=0;
	SelectedServer[UserIndex]=0;
	SelectedServerLoop[UserIndex]=1;
	return PLUGIN_CONTINUE;
}

redirect(User[],server){
	new Command[MAX_DATA_LENGTH]="connect ";
	new Text[MAX_TEXT_LENGTH];
	new Date[MAX_TEXT_LENGTH];
	servertime(Date, MAX_NUMBER_LENGTH, "%m/%d/%y %H:%M:%S");
	strcat(Command,ServerIP[server],MAX_TEXT_LENGTH);
	snprintf(Text,MAX_TEXT_LENGTH,"You will be redirected to %s!",ServerIP[server]);
	messageex(User,Text,print_chat);
	messageex(User,Text,print_console);
	execclient(User,Command);
	snprintf(Text, MAX_TEXT_LENGTH, "%s: redirected <%s> to <%s>", Date, User, Servername[server]);
	writefile(RedirectLogCFG, Text,-1);
	return PLUGIN_HANDLED;
}

